# Bind charm

A Juju charm deploying Bind, configurable to use a git repository for its configuration files.

## Overview

This is a k8s workload charm and can only be deployed to a Juju k8s cloud,
attached to a controller using `juju add-k8s`.

This charm is not currently ready for production due to issues with providing
an egress to route TCP and UDP traffic to the pods. See:

https://bugs.launchpad.net/charm-k8s-bind/+bug/1889746

https://bugs.launchpad.net/juju/+bug/1889703

## Details

See config option descriptions in config.yaml.

## Getting Started

Notes for deploying a test setup locally using microk8s:

    sudo snap install juju --classic
    sudo snap install juju-wait --classic
    sudo snap install microk8s --classic
    sudo snap alias microk8s.kubectl kubectl
    sudo snap install charmcraft
    git clone https://git.launchpad.net/charm-k8s-bind
    make bind.charm

    microk8s.reset  # Warning! Clean slate!
    microk8s.enable dns dashboard registry storage
    microk8s.status --wait-ready
    microk8s.config | juju add-k8s myk8s --client

    # Build your Bind image
    make build-image
    docker push localhost:32000/bind
    
    juju bootstrap myk8s
    juju add-model bind-test
    juju deploy ./bind.charm --config bind_image_path=localhost:32000/bind:latest bind
    juju wait
    juju status

Assuming you're using the image as built locally from this repo, the charm will
deploy bind with its stock Ubuntu package configuration, which will forward all
queries to root name servers.

DNSSEC is also enabled by default.

Custom config can be deployed by setting the `custom_config_repo` option to
point to a Git repository containing a valid set of configuration files with
which to populate the /etc/bind/ directory within the pod(s).
